// Up to 20 layers of beads around the central bead. No single bead (n=0) supported.
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "UU_3D_hcp_proj_params.h"

    
double s0[IMAX+2][JMAX+2],h0[IMAX+2][JMAX+2],s1[IMAX+2][JMAX+2],h1[IMAX+2][JMAX+2],pH[IMAX][JMAX],nu[IMAX+2][JMAX+2];
double s0L1[IMAX+3][JMAX+3],h0L1[IMAX+3][JMAX+3],s1L1[IMAX+3][JMAX+3],h1L1[IMAX+3][JMAX+3];
double s0L2[IMAX+2][JMAX+2],h0L2[IMAX+2][JMAX+2],s1L2[IMAX+2][JMAX+2],h1L2[IMAX+2][JMAX+2];
double s0L3[IMAX+3][JMAX+3],h0L3[IMAX+3][JMAX+3],s1L3[IMAX+3][JMAX+3],h1L3[IMAX+3][JMAX+3];
double sf[IMAX+2][JMAX+2],hf[IMAX+2][JMAX+2];
int i,j,k,g,l,t,nt,n,m,tc,to,bc=0,lcb=0,lc1=0,lc2=0,lc3=0,coiI=15,coiJ=15;
int gs[20] {7, 19, 37, 61, 91,127,169,217,271,331,397,469,547,631, 721, 817, 919,1027,1141,1261};
int lsb[20]{61,91,127,169,217,271,331,397,469,547,631,721,817,919,1027,1141,1261,1387,1519,1657};
int ls1[20]{48,75,108,147,192,243,300,363,432,507,588,675,768,867, 972,1083,1200,1323,1452,1587};
int ls2[20]{37,61, 91,127,169,217,271,331,397,469,547,631,721,817, 919,1027,1141,1261,1387,1519};
int ls3[20]{27,48, 75,108,147,192,243,300,363,432,507,588,675,768, 867, 972,1083,1200,1323,1452};
int* beadI;
int* beadJ;
int* LbI;
int* LbJ;
int* L1I;
int* L1J;
int* L2I;
int* L2J;
int* L3I;
int* L3J;
double E,ESig,ht,So,Ho,Sodim,Hodim,Ls,Lh,r,hs,na,xi,sum_pH;
double kE=3.7e-6,KME=0.003,KE1=5e-6,KE2=2e-9,KW=1e-14,DS=0.0014,DH=0.009;
double ka=KME/KE1, kaes=KE2/KE1, kaw=KW/KE1/KE1, d=DH/DS, tau=kE*E/KME;

double lap13pt_s(double f1,double f2,double f3,double f4,double f5,double f6,double f7,double f8,double f9,double f10,double f11,double f12,double f13,double h){
    // Compute Laplacian - grid layout for 13-point stensil for 3D hcp
    // in layer		above	 below
	//	 f6 f7  	f8 f9			
    // f3 f4 f5 	 f10	f11 f12	
    //   f1 f2  			  f13	
    double lap;
    lap=(f1+f2+f3+f5+f6+f7+f8+f9+f10+f11+f12+f13-12.0*f4)/2/h/h;
    return (lap);
    }
        
double lap13pt_h(double f1,double f2,double f3,double f4,double f5,double f6,double f7,double f8,double f9,double f10,double f11,double f12,double f13,double h,double kaw){
    double lap;
    lap=((f1-kaw/f1)+(f2-kaw/f2)+(f3-kaw/f3)+(f5-kaw/f5)+(f6-kaw/f6)+(f7-kaw/f7)+(f8-kaw/f8)+(f9-kaw/f9)+(f10-kaw/f10)+(f11-kaw/f11)+(f12-kaw/f12)+(f13-kaw/f13)-12.0*(f4-kaw/f4))/2/h/h;
    return (lap);
    }
        
double Rate(double s, double h, double kaes, double nu){
    // Compute "r" in the 2-variable Urea-Urease scaled/nondimensional model
    double RES;
    RES=nu*s/(1+kaes/h+h)/(1+s);
    return (RES);
    }
    
double randn (double mu, double sigma){
  	double U1, U2, W, mult;
  	static double X1, X2;
  	static int call = 0;
  	if (call == 1){
      	call = !call;
      	return (mu + sigma * (double) X2);
    }
  	do{
      	U1 = -1 + ((double) rand () / RAND_MAX) * 2;
      	U2 = -1 + ((double) rand () / RAND_MAX) * 2;
      	W = pow (U1, 2) + pow (U2, 2);
    }
  	while (W >= 1 || W == 0);
  	mult = sqrt ((-2 * log (W)) / W);
  	X1 = U1 * mult;
  	X2 = U2 * mult;
 	call = !call;
 	return (mu + sigma * (double) X1);
}


int main(int argc, char *argv[]) {
    
    char fnuout[60],fnvout[60],fn[60];
    FILE *uout,*vout;
	na=1.0; /* noise amplitude*/
	tc=0;
	sscanf(argv[1],"%i",&to);      /* file output frequency, every "to"-th file written out */
	sscanf(argv[2],"%i",&nt);      /* number of iterations */
	sscanf(argv[3],"%s",&fn);      /* root of output file names */
	sscanf(argv[4],"%lf",&ht);     /* ht (timestep) */
	sscanf(argv[5],"%lf",&Sodim);  /* S0 */ 
	sscanf(argv[6],"%lf",&Hodim);  /* H0 */
	sscanf(argv[7],"%lf",&E);      /* E */
	sscanf(argv[8],"%lf",&ESig);   /* Sigma(E) */
	sscanf(argv[9],"%i",&n);       /* number of layers of beads about bead in center */
	sscanf(argv[10],"%lf",&hs);    /* spatial stepsize in mm */
	xi=sqrt(kE*E/DS/KME)*hs;
    So=Sodim/KME; Ho=Hodim/KE1;
    beadI = (int*) malloc(gs[n-1]*sizeof(int));
    beadJ = (int*) malloc(gs[n-1]*sizeof(int));
    LbI = (int*) malloc(lsb[n-1]*sizeof(int));
    LbJ = (int*) malloc(lsb[n-1]*sizeof(int));
    L1I = (int*) malloc(ls1[n-1]*sizeof(int));
    L1J = (int*) malloc(ls1[n-1]*sizeof(int));
    L2I = (int*) malloc(ls2[n-1]*sizeof(int));
    L2J = (int*) malloc(ls2[n-1]*sizeof(int));
    L3I = (int*) malloc(ls3[n-1]*sizeof(int));
    L3J = (int*) malloc(ls3[n-1]*sizeof(int));
	printf("\n number of iterations: %i;\n every %ith file will be written out;\n file name root: %s_ph_*\n timestep: %lf;\n [S]0: %lf; s0: %lf;\n [H]0: %lf; h0: %lf;\n E: %lf; E_sig: %lf;\n hs: %lf; xi: %lf\n\n",nt,to,fn,ht,Sodim,So,Hodim,Ho,E,ESig,hs,xi);
	
	srand(time(NULL));
   	for(i=0;i<=IMAX+1;i++){ // generating spatial random noise
       	for(j=0;j<=JMAX+1;j++){
		    nu[i][j]=randn(E,ESig)/E;
		}
	}
	sprintf(fnvout,"%s_nu_enz",fn);
	vout=fopen(fnvout, "wb");
	for(i=1;i<=IMAX;i++){
		fwrite(&nu[i][1],sizeof(double),JMAX,vout);
	}
	fclose(vout);
	printf("%s\n",fnvout);
	// No boundary contitions are defined for the sides of arrays so the all elements of arrays are initialized (instead of leaving the edges undefined in this step).
    for(i=0;i<=IMAX+1;i++){ // setting initial conditions
        for(j=0;j<=JMAX+1;j++){
		    s0[i][j]=So;	// beads
		    h0[i][j]=Ho;
		    s0L2[i][j]=So;	// L2
		    h0L2[i][j]=Ho;
		}
	}
	for(i=0;i<=IMAX+2;i++){ // setting initial conditions L1, L3
        for(j=0;j<=JMAX+2;j++){
			s0L1[i][j]=So;
		    h0L1[i][j]=Ho;
		    s0L3[i][j]=So;
		    h0L3[i][j]=Ho;
		}
	}
	// BEADS LAYER INITIALIZATION
		for(j=coiJ-n-3;j<=coiJ+n+3;j++){
		    	LbI[lcb]=coiI;
		    	LbJ[lcb]=j;
		    	lcb++;
		}
		m=0;
		for(k=1;k<=n+3;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-3;j<=coiJ+n-m+1+3;j++){
		    		LbI[lcb]=i;
		    		LbJ[lcb]=j;
		    		lcb++;
				}
			}
		}
		m=0;
		for(k=2;k<=n+3;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-3;j<=coiJ+n-m+3;j++){
		    		LbI[lcb]=i;
		    		LbJ[lcb]=j;
		    		lcb++;
				}
			}
		}
	// L1 INITIALIZATION
		for(j=coiJ-n-2;j<=coiJ+n+3;j++){
		    	L1I[lc1]=coiI;
		    	L1J[lc1]=j;
				lc1++;
		}
		m=0;
		for(k=1;k<=n+2;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-2;j<=coiJ+n-m+1+3;j++){
		    		L1I[lc1]=i;
		    		L1J[lc1]=j;
		    		lc1++;
				}
			}
		}
		if (n%2 == 0){
			m++;
			k+=2;
			i=coiI+n+3;
			for(j=coiJ-n+m-2;j<=coiJ+n-m+1+3;j++){
			    L1I[lc1]=i;
			    L1J[lc1]=j;
			    lc1++;
			}
		}
		m=0;
		for(k=2;k<=n+2;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-2;j<=coiJ+n-m+3;j++){
		    		L1I[lc1]=i;
		    		L1J[lc1]=j;
		    		lc1++;
				}
			}
		}
		if (n%2 != 0){
			m++;
			k+=2;
			i=coiI+n+3;
			for(j=coiJ-n+m-2;j<=coiJ+n-m+3;j++){
			    L1I[lc1]=i;
			    L1J[lc1]=j;
			    lc1++;
			}
		}
	// L2 INITIALIZATION
	n--;
		for(j=coiJ-n-3;j<=coiJ+n+3;j++){
		    	L2I[lc2]=coiI;
		    	L2J[lc2]=j;
		    	lc2++;
		}
		m=0;
		for(k=1;k<=n+3;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-3;j<=coiJ+n-m+1+3;j++){
		    		L2I[lc2]=i;
		    		L2J[lc2]=j;
		    		lc2++;
				}
			}
		}
		m=0;
		for(k=2;k<=n+3;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-3;j<=coiJ+n-m+3;j++){
		    		L2I[lc2]=i;
		    		L2J[lc2]=j;
		    		lc2++;
				}
			}
		}
	// L3 INITIALIZATION
		for(j=coiJ-n-2;j<=coiJ+n+3;j++){
		    	L3I[lc3]=coiI;
		    	L3J[lc3]=j;
				lc3++;
		}
		m=0;
		for(k=1;k<=n+2;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-2;j<=coiJ+n-m+1+3;j++){
		    		L3I[lc3]=i;
		    		L3J[lc3]=j;
		    		lc3++;
				}
			}
		}
		if (n%2 == 0){
			m++;
			k+=2;
			i=coiI+n+3;
			for(j=coiJ-n+m-2;j<=coiJ+n-m+1+3;j++){
			    L3I[lc3]=i;
		    	L3J[lc3]=j;
		    	lc3++;
			}
		}
		m=0;
		for(k=2;k<=n+2;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m-2;j<=coiJ+n-m+3;j++){
		    		L3I[lc3]=i;
		    		L3J[lc3]=j;
		    		lc3++;
				}
			}
		}
		if (n%2 != 0){
			m++;
			k+=2;
			i=coiI+n+3;
			for(j=coiJ-n+m-2;j<=coiJ+n-m+3;j++){
			    L3I[lc3]=i;
		    	L3J[lc3]=j;
		    	lc3++;
			}
		}
	// beads initialization
	n++; // for L2 and L3 n was reduced by one so it need increaseing back to its original value
		for(j=coiJ-n;j<=coiJ+n;j++){
		    	beadI[bc]=coiI;
		    	beadJ[bc]=j;
		    	bc++;
			}
		m=0;
		for(k=1;k<=n;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m;j<=coiJ+n-m+1;j++){
		    		beadI[bc]=i;
		    		beadJ[bc]=j;
		    		bc++;
				}
			}
		}
		m=0;
		for(k=2;k<=n;k+=2){
			m++;
			for(i=coiI-k;i<=coiI+k;i+=2*k){
				for(j=coiJ-n+m;j<=coiJ+n-m;j++){
		    		beadI[bc]=i;
		    		beadJ[bc]=j;
		    		bc++;
				}
			}
		}
	//	printf("%i %i %i %i %i\n",bc,lcb,lc1,lc2,lc3);
// end of beads + L3
		
    for(t=0;t<=nt;t++){
		// Euler
		// L3
		for(i=0;i<=IMAX+3;i++){
			for(j=0;j<=JMAX+3;j++){
				s1L3[i][j]=s0L3[i][j];
                h1L3[i][j]=h0L3[i][j];
			}
		}
		for(l=0;l<ls3[n-1];l++){
			i=L3I[l]; j=L3J[l];
			if (i%2 == 0){
                Ls=lap13pt_s(s0L3[i+1][j-1],s0L3[i+1][j],s0L3[i][j-1],s0L3[i][j],s0L3[i][j+1],s0L3[i-1][j-1],s0L3[i-1][j],So,So,So,s0L2[i-1][j-1],s0L2[i][j],s0L2[i][j-1],xi);
                Lh=lap13pt_h(h0L3[i+1][j-1],h0L3[i+1][j],h0L3[i][j-1],h0L3[i][j],h0L3[i][j+1],h0L3[i-1][j-1],h0L3[i-1][j],Ho,Ho,Ho,h0L2[i-1][j-1],h0L2[i][j],h0L2[i][j-1],xi,kaw);
            } else {
                Ls=lap13pt_s(s0L3[i+1][j],s0L3[i+1][j+1],s0L3[i][j-1],s0L3[i][j],s0L3[i][j+1],s0L3[i-1][j],s0L3[i-1][j+1],So,So,So,s0L2[i-1][j],s0L2[i][j],s0L2[i][j-1],xi);
                Lh=lap13pt_h(h0L3[i+1][j],h0L3[i+1][j+1],h0L3[i][j-1],h0L3[i][j],h0L3[i][j+1],h0L3[i-1][j],h0L3[i-1][j+1],Ho,Ho,Ho,h0L2[i-1][j],h0L2[i][j],h0L2[i][j-1],xi,kaw);
            }
            s1L3[i][j]=s0L3[i][j]+Ls*ht;
			h1L3[i][j]=h0L3[i][j]+d*Lh*ht;
		}
		// L2
		for(i=0;i<=IMAX+2;i++){
			for(j=0;j<=JMAX+2;j++){
				s1L2[i][j]=s0L2[i][j];
                h1L2[i][j]=h0L2[i][j];
			}
		}
		for(l=0;l<ls2[n-1];l++){
			i=L2I[l]; j=L2J[l];
			if (i%2 == 0){
                Ls=lap13pt_s(s0L2[i+1][j-1],s0L2[i+1][j],s0L2[i][j-1],s0L2[i][j],s0L2[i][j+1],s0L2[i-1][j-1],s0L2[i-1][j],s0L3[i][j],s0L3[i][j+1],s0L3[i+1][j],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j],xi);
                Lh=lap13pt_h(h0L2[i+1][j-1],h0L2[i+1][j],h0L2[i][j-1],h0L2[i][j],h0L2[i][j+1],h0L2[i-1][j-1],h0L2[i-1][j],h0L3[i][j],h0L3[i][j+1],h0L3[i+1][j],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j],xi,kaw);
            } else {
                Ls=lap13pt_s(s0L2[i+1][j],s0L2[i+1][j+1],s0L2[i][j-1],s0L2[i][j],s0L2[i][j+1],s0L2[i-1][j],s0L2[i-1][j+1],s0L3[i][j],s0L3[i][j+1],s0L3[i+1][j+1],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j+1],xi);
                Lh=lap13pt_h(h0L2[i+1][j],h0L2[i+1][j+1],h0L2[i][j-1],h0L2[i][j],h0L2[i][j+1],h0L2[i-1][j],h0L2[i-1][j+1],h0L3[i][j],h0L3[i][j+1],h0L3[i+1][j+1],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j+1],xi,kaw);
            }
            s1L2[i][j]=s0L2[i][j]+Ls*ht;
			h1L2[i][j]=h0L2[i][j]+d*Lh*ht;
		}
		// L1
		for(i=0;i<=IMAX+3;i++){
			for(j=0;j<=JMAX+3;j++){
				s1L1[i][j]=s0L1[i][j];
                h1L1[i][j]=h0L1[i][j];
			}
		}
		for(l=0;l<ls1[n-1];l++){
			i=L1I[l]; j=L1J[l];
			if (i%2 == 0){
                Ls=lap13pt_s(s0L1[i+1][j-1],s0L1[i+1][j],s0L1[i][j-1],s0L1[i][j],s0L1[i][j+1],s0L1[i-1][j-1],s0L1[i-1][j],s0L2[i-1][j-1],s0L2[i][j],s0L2[i][j-1],s0[i-1][j-1],s0[i][j],s0[i][j-1],xi);
                Lh=lap13pt_h(h0L1[i+1][j-1],h0L1[i+1][j],h0L1[i][j-1],h0L1[i][j],h0L1[i][j+1],h0L1[i-1][j-1],h0L1[i-1][j],h0L2[i-1][j-1],h0L2[i][j],h0L2[i][j-1],h0[i-1][j-1],h0[i][j],h0[i][j-1],xi,kaw);
            } else {
                Ls=lap13pt_s(s0L1[i+1][j],s0L1[i+1][j+1],s0L1[i][j-1],s0L1[i][j],s0L1[i][j+1],s0L1[i-1][j],s0L1[i-1][j+1],s0L2[i-1][j],s0L2[i][j],s0L2[i][j-1],s0[i-1][j],s0[i][j],s0[i][j-1],xi);
                Lh=lap13pt_h(h0L1[i+1][j],h0L1[i+1][j+1],h0L1[i][j-1],h0L1[i][j],h0L1[i][j+1],h0L1[i-1][j],h0L1[i-1][j+1],h0L2[i-1][j],h0L2[i][j],h0L2[i][j-1],h0[i-1][j],h0[i][j],h0[i][j-1],xi,kaw);
            }
            s1L1[i][j]=s0L1[i][j]+Ls*ht;
			h1L1[i][j]=h0L1[i][j]+d*Lh*ht;
		}
		// Beads layer
		for(i=0;i<=IMAX+1;i++){
            for(j=0;j<=JMAX+1;j++){
				s1[i][j]=s0[i][j];
	            h1[i][j]=h0[i][j];
	    	}
		}
		for(l=0;l<lsb[n-1];l++){
			i=LbI[l]; j=LbJ[l];
                if (i%2 == 0){
                    Ls=lap13pt_s(s0[i+1][j-1],s0[i+1][j],s0[i][j-1],s0[i][j],s0[i][j+1],s0[i-1][j-1],s0[i-1][j],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j],s0[i][j],s0[i][j],s0[i][j],xi);
                    Lh=lap13pt_h(h0[i+1][j-1],h0[i+1][j],h0[i][j-1],h0[i][j],h0[i][j+1],h0[i-1][j-1],h0[i-1][j],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j],h0[i][j],h0[i][j],h0[i][j],xi,kaw);
                } else {
                    Ls=lap13pt_s(s0[i+1][j],s0[i+1][j+1],s0[i][j-1],s0[i][j],s0[i][j+1],s0[i-1][j],s0[i-1][j+1],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j+1],s0[i][j],s0[i][j],s0[i][j],xi);
                    Lh=lap13pt_h(h0[i+1][j],h0[i+1][j+1],h0[i][j-1],h0[i][j],h0[i][j+1],h0[i-1][j],h0[i-1][j+1],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j+1],h0[i][j],h0[i][j],h0[i][j],xi,kaw);
                }
				s1[i][j]=s0[i][j]+Ls*ht;
				h1[i][j]=h0[i][j]+d*Lh*ht;
		}
	    for(g=0;g<gs[n-1];g++){
			i=beadI[g]; j=beadJ[g];
                if (i%2 == 0){
                    Ls=lap13pt_s(s0[i+1][j-1],s0[i+1][j],s0[i][j-1],s0[i][j],s0[i][j+1],s0[i-1][j-1],s0[i-1][j],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j],s0[i][j],s0[i][j],s0[i][j],xi);
                    Lh=lap13pt_h(h0[i+1][j-1],h0[i+1][j],h0[i][j-1],h0[i][j],h0[i][j+1],h0[i-1][j-1],h0[i-1][j],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j],h0[i][j],h0[i][j],h0[i][j],xi,kaw);
                } else {
                    Ls=lap13pt_s(s0[i+1][j],s0[i+1][j+1],s0[i][j-1],s0[i][j],s0[i][j+1],s0[i-1][j],s0[i-1][j+1],s0L1[i][j],s0L1[i][j+1],s0L1[i+1][j+1],s0[i][j],s0[i][j],s0[i][j],xi);
                    Lh=lap13pt_h(h0[i+1][j],h0[i+1][j+1],h0[i][j-1],h0[i][j],h0[i][j+1],h0[i-1][j],h0[i-1][j+1],h0L1[i][j],h0L1[i][j+1],h0L1[i+1][j+1],h0[i][j],h0[i][j],h0[i][j],xi,kaw);
                }
                r=Rate(s0[i][j],h0[i][j],kaes,nu[i][j]);
				s1[i][j]=s0[i][j]+(Ls-r)*ht;
				h1[i][j]=h0[i][j]+(d*Lh-2*ka*r)/(1+kaw/h0[i][j]/h0[i][j])*ht;
			
		}
		tc++;	
		if(tc==to || t==0){
            for(i=1;i<=IMAX;i++){ // h conversion to pH
               for(j=1;j<=JMAX;j++){
		          pH[i][j]=-1.0*log10(h0[i][j]*KE1);
		        }
	        }
	        sum_pH=0.0;
			for(g=0;g<gs[n-1];g++){
				i=beadI[g]; j=beadJ[g];
				sum_pH+=pH[i][j];
				//printf("%i  %i\n",i,j);
			}
			pH[1][1]=sum_pH/gs[n];
            sprintf(fnuout,"%s_ph_%i",fn,t);
			uout=fopen(fnuout, "wb");
			for(i=1;i<=IMAX;i++){
				fwrite(&pH[i][1],sizeof(double),JMAX,uout);
			}
			fclose(uout);
			//sprintf(fnvout,"%s_H_%i",fn,t);
			//vout=fopen(fnvout, "wb");
			//for(i=1;i<=IMAX;i++){
			//	fwrite(&h0[i][1],sizeof(double),JMAX,vout);
			//	}
			//fclose(vout);
			// printf("%s  %s\n",fnuout,fnvout);
			printf("%s\n",fnuout);
			tc=0;
			}
		for(i=1;i<=IMAX;i++){
            for(j=1;j<=JMAX;j++){
		        s0[i][j]=s1[i][j];
                h0[i][j]=h1[i][j];
                s0L2[i][j]=s1L2[i][j];
                h0L2[i][j]=h1L2[i][j];
		    }
		}
		for(i=1;i<=IMAX+1;i++){
            for(j=1;j<=JMAX+1;j++){
               	s0L1[i][j]=s1L1[i][j];
                h0L1[i][j]=h1L1[i][j];
                s0L3[i][j]=s1L3[i][j];
                h0L3[i][j]=h1L3[i][j];
		    }
		}	
    } // t
}
